/* $XFree86: xc/programs/Xserver/hw/xfree86/int10/xf86x86emu.h,v 1.2 2001/01/06 20:19:13 tsi Exp $ */
/*
 *                   XFree86 int10 module
 *   execute BIOS int 10h calls in x86 real mode environment
 *                 Copyright 1999 Egbert Eich
 */
#ifndef XF86X86EMU_H_
#define XF86X86EMU_H_
#include <x86emu.h>
#include <regs.h>

/* int10 info structure */
struct int10_info
{
#if 0
	//	u16 BIOSseg;
	//	u16 inb40time;
	//	struct _mem *mem;
#endif
	int num;
	int ax;
	int bx;
	int cx;
	int dx;
	int si;
	int di;
	int es;
	int bp;
	int flags;
	int stackseg;
};


#define MEM_WB(where, what) wrb(where,what)
#define MEM_WW(where, what) wrw(where, what)
#define MEM_WL(where, what) wrl(where, what)

#define MEM_RB(where) rdb(where)
#define MEM_RW(where) rdw(where)
#define MEM_RL(where) rdl(where)

#define die(x) { perror(x); exit(1); }
#define warn(x) { perror(x);  }

extern struct int10_info *current;

extern int run_bios_int(int num);
extern u32 getIntVect(int num);

extern void x86emu_dump_xregs(void);
extern int int15_handler(void);
extern int int16_handler(void);
extern int int1A_handler(void);
#ifndef _PC
extern int int42_handler(void);
#endif
extern int intE6_handler(void);

extern void pushw(u16 val);

extern int teststart, testend;

extern u8 x_inb(u16 port);
extern u16 x_inw(u16 port);
extern void x_outb(u16 port, u8 val);
extern void x_outw(u16 port, u16 val);
extern u32 x_inl(u16 port);
extern void x_outl(u16 port, u32 val);

extern u8 x_rdb(u32 addr);
extern u16 x_rdw(u32 addr);
extern u32 x_rdl(u32 addr);
extern void x_wrb(u32 addr, u8 val);
extern void x_wrw(u32 addr, u16 val);
extern void x_wrl(u32 addr, u32 val);

extern int setup_int(struct int10_info * pInt);
extern void finish_int(struct int10_info * pInt);

#endif
